/* SolvNmo vel=1.5 <infile.H >outfile.H
 * Applies inverse NMO operator to dataset, given velocity vel.  
 */
#include <SEPinit.h>
#include <fopnmo.h>
#include <hestsolver.h>

main(int argc,char **argv) {
    SepInput * sepInput = SEPinit(argc,argv,SOURCE);// Seplib initialization

    int niter=5; sepInput->Getch("niter",niter);    // command line arguments
    float vel=1.5; sepInput->Getch("vel",vel);

    floatspace input(sepInput);                     // make input space 
    Axislist inaxlist = input.getaxislist();        // retrive axis info

    fopNMO op(inaxlist[0],inaxlist[1],1/vel);       // make NMO operator

    HestSolver solver( op, niter );                 // construct solver object
    solver.ReportOn(cerr);                          // report progress on stderr
    floatspacearray output = solver.Solve( input ); // solve the problem

     // write to output
    SepOutput *sepout = new SepOutput("stdout", output(0,0).sepData() );
    delete sepout;

    UnRef(sepInput); return 0; // cleanup
}
