#ifndef LSSOLVER_H
#define LSSOLVER_H
// abstract base class for least squares solver, 
// the solve operation takes a RHS 
// and solves the problem min ( || op( x ) - rhs ||^2 

#include <foperator.h>
#include <floatspacea.h>

class LSSolver {

public:
    LSSolver( foperator& op );
    virtual ~LSSolver();

    virtual floatspacearray Solve(  const floatspacearray & rhs )=0; 

protected:
    foperator * op;
};
#endif
