#ifndef _NORM_CG_
#define _NORM_CG_

// solve min || A x - y ||^2 given x0
// This class uses the CG method on the normal equations.
// It is known to have poor stability properties because it
//  squares the singular values  of the equation beong solved.

#include <itersolver.h>

class NormCGSolver : public IterSolver {
public:

  NormCGSolver( foperator & fop, int maxit=10 ) : IterSolver( fop, maxit ){};

  floatspacearray Solve( const floatspacearray & rhs, 
			 const floatspacearray & initial);

  floatspacearray Solve( const floatspacearray & rhs )
	{ return IterSolver::Solve( rhs ); }
 
};
#endif
